<?php

namespace Shop\Models\Shop\Map;

use Propel\Runtime\Propel;
use Propel\Runtime\ActiveQuery\Criteria;
use Propel\Runtime\ActiveQuery\InstancePoolTrait;
use Propel\Runtime\Connection\ConnectionInterface;
use Propel\Runtime\DataFetcher\DataFetcherInterface;
use Propel\Runtime\Exception\PropelException;
use Propel\Runtime\Map\RelationMap;
use Propel\Runtime\Map\TableMap;
use Propel\Runtime\Map\TableMapTrait;
use Shop\Models\Shop\ShopShopsArchive;
use Shop\Models\Shop\ShopShopsArchiveQuery;


/**
 * This class defines the structure of the 'shop_shops_archive' table.
 *
 *
 *
 * This map class is used by Propel to do runtime db structure discovery.
 * For example, the createSelectSql() method checks the type of a given column used in an
 * ORDER BY clause to know whether it needs to apply SQL to make the ORDER BY case-insensitive
 * (i.e. if it's a text column type).
 */
class ShopShopsArchiveTableMap extends TableMap
{
    use InstancePoolTrait;
    use TableMapTrait;

    /**
     * The (dot-path) name of this class
     */
    const CLASS_NAME = 'Models.Shop.Map.ShopShopsArchiveTableMap';

    /**
     * The default database name for this class
     */
    const DATABASE_NAME = 'default';

    /**
     * The table name for this class
     */
    const TABLE_NAME = 'shop_shops_archive';

    /**
     * The related Propel class for this table
     */
    const OM_CLASS = '\\Shop\\Models\\Shop\\ShopShopsArchive';

    /**
     * A class that can be returned by this tableMap
     */
    const CLASS_DEFAULT = 'Models.Shop.ShopShopsArchive';

    /**
     * The total number of columns
     */
    const NUM_COLUMNS = 14;

    /**
     * The number of lazy-loaded columns
     */
    const NUM_LAZY_LOAD_COLUMNS = 0;

    /**
     * The number of columns to hydrate (NUM_COLUMNS - NUM_LAZY_LOAD_COLUMNS)
     */
    const NUM_HYDRATE_COLUMNS = 14;

    /**
     * the column name for the id field
     */
    const COL_ID = 'shop_shops_archive.id';

    /**
     * the column name for the title field
     */
    const COL_TITLE = 'shop_shops_archive.title';

    /**
     * the column name for the desc field
     */
    const COL_DESC = 'shop_shops_archive.desc';

    /**
     * the column name for the image field
     */
    const COL_IMAGE = 'shop_shops_archive.image';

    /**
     * the column name for the logo field
     */
    const COL_LOGO = 'shop_shops_archive.logo';

    /**
     * the column name for the director_contact field
     */
    const COL_DIRECTOR_CONTACT = 'shop_shops_archive.director_contact';

    /**
     * the column name for the phones field
     */
    const COL_PHONES = 'shop_shops_archive.phones';

    /**
     * the column name for the emails field
     */
    const COL_EMAILS = 'shop_shops_archive.emails';

    /**
     * the column name for the type field
     */
    const COL_TYPE = 'shop_shops_archive.type';

    /**
     * the column name for the parent_id field
     */
    const COL_PARENT_ID = 'shop_shops_archive.parent_id';

    /**
     * the column name for the domain_id field
     */
    const COL_DOMAIN_ID = 'shop_shops_archive.domain_id';

    /**
     * the column name for the active field
     */
    const COL_ACTIVE = 'shop_shops_archive.active';

    /**
     * the column name for the contractor_id field
     */
    const COL_CONTRACTOR_ID = 'shop_shops_archive.contractor_id';

    /**
     * the column name for the archived_at field
     */
    const COL_ARCHIVED_AT = 'shop_shops_archive.archived_at';

    /**
     * The default string format for model objects of the related table
     */
    const DEFAULT_STRING_FORMAT = 'YAML';

    /**
     * holds an array of fieldnames
     *
     * first dimension keys are the type constants
     * e.g. self::$fieldNames[self::TYPE_PHPNAME][0] = 'Id'
     */
    protected static $fieldNames = array (
        self::TYPE_PHPNAME       => array('Id', 'Title', 'Desc', 'Image', 'Logo', 'directorContact', 'Phones', 'emails', 'Type', 'ParentId', 'DomainId', 'Active', 'ContractorId', 'ArchivedAt', ),
        self::TYPE_CAMELNAME     => array('id', 'title', 'desc', 'image', 'logo', 'directorContact', 'phones', 'emails', 'type', 'parentId', 'domainId', 'active', 'contractorId', 'archivedAt', ),
        self::TYPE_COLNAME       => array(ShopShopsArchiveTableMap::COL_ID, ShopShopsArchiveTableMap::COL_TITLE, ShopShopsArchiveTableMap::COL_DESC, ShopShopsArchiveTableMap::COL_IMAGE, ShopShopsArchiveTableMap::COL_LOGO, ShopShopsArchiveTableMap::COL_DIRECTOR_CONTACT, ShopShopsArchiveTableMap::COL_PHONES, ShopShopsArchiveTableMap::COL_EMAILS, ShopShopsArchiveTableMap::COL_TYPE, ShopShopsArchiveTableMap::COL_PARENT_ID, ShopShopsArchiveTableMap::COL_DOMAIN_ID, ShopShopsArchiveTableMap::COL_ACTIVE, ShopShopsArchiveTableMap::COL_CONTRACTOR_ID, ShopShopsArchiveTableMap::COL_ARCHIVED_AT, ),
        self::TYPE_FIELDNAME     => array('id', 'title', 'desc', 'image', 'logo', 'director_contact', 'phones', 'emails', 'type', 'parent_id', 'domain_id', 'active', 'contractor_id', 'archived_at', ),
        self::TYPE_NUM           => array(0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, )
    );

    /**
     * holds an array of keys for quick access to the fieldnames array
     *
     * first dimension keys are the type constants
     * e.g. self::$fieldKeys[self::TYPE_PHPNAME]['Id'] = 0
     */
    protected static $fieldKeys = array (
        self::TYPE_PHPNAME       => array('Id' => 0, 'Title' => 1, 'Desc' => 2, 'Image' => 3, 'Logo' => 4, 'directorContact' => 5, 'Phones' => 6, 'emails' => 7, 'Type' => 8, 'ParentId' => 9, 'DomainId' => 10, 'Active' => 11, 'ContractorId' => 12, 'ArchivedAt' => 13, ),
        self::TYPE_CAMELNAME     => array('id' => 0, 'title' => 1, 'desc' => 2, 'image' => 3, 'logo' => 4, 'directorContact' => 5, 'phones' => 6, 'emails' => 7, 'type' => 8, 'parentId' => 9, 'domainId' => 10, 'active' => 11, 'contractorId' => 12, 'archivedAt' => 13, ),
        self::TYPE_COLNAME       => array(ShopShopsArchiveTableMap::COL_ID => 0, ShopShopsArchiveTableMap::COL_TITLE => 1, ShopShopsArchiveTableMap::COL_DESC => 2, ShopShopsArchiveTableMap::COL_IMAGE => 3, ShopShopsArchiveTableMap::COL_LOGO => 4, ShopShopsArchiveTableMap::COL_DIRECTOR_CONTACT => 5, ShopShopsArchiveTableMap::COL_PHONES => 6, ShopShopsArchiveTableMap::COL_EMAILS => 7, ShopShopsArchiveTableMap::COL_TYPE => 8, ShopShopsArchiveTableMap::COL_PARENT_ID => 9, ShopShopsArchiveTableMap::COL_DOMAIN_ID => 10, ShopShopsArchiveTableMap::COL_ACTIVE => 11, ShopShopsArchiveTableMap::COL_CONTRACTOR_ID => 12, ShopShopsArchiveTableMap::COL_ARCHIVED_AT => 13, ),
        self::TYPE_FIELDNAME     => array('id' => 0, 'title' => 1, 'desc' => 2, 'image' => 3, 'logo' => 4, 'director_contact' => 5, 'phones' => 6, 'emails' => 7, 'type' => 8, 'parent_id' => 9, 'domain_id' => 10, 'active' => 11, 'contractor_id' => 12, 'archived_at' => 13, ),
        self::TYPE_NUM           => array(0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, )
    );

    /**
     * Initialize the table attributes and columns
     * Relations are not initialized by this method since they are lazy loaded
     *
     * @return void
     * @throws PropelException
     */
    public function initialize()
    {
        // attributes
        $this->setName('shop_shops_archive');
        $this->setPhpName('ShopShopsArchive');
        $this->setIdentifierQuoting(true);
        $this->setClassName('\\Shop\\Models\\Shop\\ShopShopsArchive');
        $this->setPackage('Models.Shop');
        $this->setUseIdGenerator(false);
        // columns
        $this->addPrimaryKey('id', 'Id', 'INTEGER', true, null, null);
        $this->addColumn('title', 'Title', 'VARCHAR', true, 255, null);
        $this->addColumn('desc', 'Desc', 'LONGVARCHAR', false, null, null);
        $this->addColumn('image', 'Image', 'VARCHAR', false, 255, null);
        $this->addColumn('logo', 'Logo', 'VARCHAR', false, 255, null);
        $this->addColumn('director_contact', 'directorContact', 'LONGVARCHAR', false, null, null);
        $this->addColumn('phones', 'Phones', 'LONGVARCHAR', false, null, null);
        $this->addColumn('emails', 'emails', 'LONGVARCHAR', false, null, null);
        $this->addColumn('type', 'Type', 'CHAR', true, null, 'main');
        $this->addColumn('parent_id', 'ParentId', 'INTEGER', false, null, null);
        $this->addColumn('domain_id', 'DomainId', 'INTEGER', false, null, null);
        $this->addColumn('active', 'Active', 'CHAR', true, null, 'Y');
        $this->addColumn('contractor_id', 'ContractorId', 'INTEGER', false, null, null);
        $this->addColumn('archived_at', 'ArchivedAt', 'TIMESTAMP', false, null, null);
    } // initialize()

    /**
     * Build the RelationMap objects for this table relationships
     */
    public function buildRelations()
    {
    } // buildRelations()

    /**
     * Retrieves a string version of the primary key from the DB resultset row that can be used to uniquely identify a row in this table.
     *
     * For tables with a single-column primary key, that simple pkey value will be returned.  For tables with
     * a multi-column primary key, a serialize()d version of the primary key will be returned.
     *
     * @param array  $row       resultset row.
     * @param int    $offset    The 0-based offset for reading from the resultset row.
     * @param string $indexType One of the class type constants TableMap::TYPE_PHPNAME, TableMap::TYPE_CAMELNAME
     *                           TableMap::TYPE_COLNAME, TableMap::TYPE_FIELDNAME, TableMap::TYPE_NUM
     *
     * @return string The primary key hash of the row
     */
    public static function getPrimaryKeyHashFromRow($row, $offset = 0, $indexType = TableMap::TYPE_NUM)
    {
        // If the PK cannot be derived from the row, return NULL.
        if ($row[TableMap::TYPE_NUM == $indexType ? 0 + $offset : static::translateFieldName('Id', TableMap::TYPE_PHPNAME, $indexType)] === null) {
            return null;
        }

        return null === $row[TableMap::TYPE_NUM == $indexType ? 0 + $offset : static::translateFieldName('Id', TableMap::TYPE_PHPNAME, $indexType)] || is_scalar($row[TableMap::TYPE_NUM == $indexType ? 0 + $offset : static::translateFieldName('Id', TableMap::TYPE_PHPNAME, $indexType)]) || is_callable([$row[TableMap::TYPE_NUM == $indexType ? 0 + $offset : static::translateFieldName('Id', TableMap::TYPE_PHPNAME, $indexType)], '__toString']) ? (string) $row[TableMap::TYPE_NUM == $indexType ? 0 + $offset : static::translateFieldName('Id', TableMap::TYPE_PHPNAME, $indexType)] : $row[TableMap::TYPE_NUM == $indexType ? 0 + $offset : static::translateFieldName('Id', TableMap::TYPE_PHPNAME, $indexType)];
    }

    /**
     * Retrieves the primary key from the DB resultset row
     * For tables with a single-column primary key, that simple pkey value will be returned.  For tables with
     * a multi-column primary key, an array of the primary key columns will be returned.
     *
     * @param array  $row       resultset row.
     * @param int    $offset    The 0-based offset for reading from the resultset row.
     * @param string $indexType One of the class type constants TableMap::TYPE_PHPNAME, TableMap::TYPE_CAMELNAME
     *                           TableMap::TYPE_COLNAME, TableMap::TYPE_FIELDNAME, TableMap::TYPE_NUM
     *
     * @return mixed The primary key of the row
     */
    public static function getPrimaryKeyFromRow($row, $offset = 0, $indexType = TableMap::TYPE_NUM)
    {
        return (int) $row[
            $indexType == TableMap::TYPE_NUM
                ? 0 + $offset
                : self::translateFieldName('Id', TableMap::TYPE_PHPNAME, $indexType)
        ];
    }

    /**
     * The class that the tableMap will make instances of.
     *
     * If $withPrefix is true, the returned path
     * uses a dot-path notation which is translated into a path
     * relative to a location on the PHP include_path.
     * (e.g. path.to.MyClass -> 'path/to/MyClass.php')
     *
     * @param boolean $withPrefix Whether or not to return the path with the class name
     * @return string path.to.ClassName
     */
    public static function getOMClass($withPrefix = true)
    {
        return $withPrefix ? ShopShopsArchiveTableMap::CLASS_DEFAULT : ShopShopsArchiveTableMap::OM_CLASS;
    }

    /**
     * Populates an object of the default type or an object that inherit from the default.
     *
     * @param array  $row       row returned by DataFetcher->fetch().
     * @param int    $offset    The 0-based offset for reading from the resultset row.
     * @param string $indexType The index type of $row. Mostly DataFetcher->getIndexType().
                                 One of the class type constants TableMap::TYPE_PHPNAME, TableMap::TYPE_CAMELNAME
     *                           TableMap::TYPE_COLNAME, TableMap::TYPE_FIELDNAME, TableMap::TYPE_NUM.
     *
     * @throws PropelException Any exceptions caught during processing will be
     *                         rethrown wrapped into a PropelException.
     * @return array           (ShopShopsArchive object, last column rank)
     */
    public static function populateObject($row, $offset = 0, $indexType = TableMap::TYPE_NUM)
    {
        $key = ShopShopsArchiveTableMap::getPrimaryKeyHashFromRow($row, $offset, $indexType);
        if (null !== ($obj = ShopShopsArchiveTableMap::getInstanceFromPool($key))) {
            // We no longer rehydrate the object, since this can cause data loss.
            // See http://www.propelorm.org/ticket/509
            // $obj->hydrate($row, $offset, true); // rehydrate
            $col = $offset + ShopShopsArchiveTableMap::NUM_HYDRATE_COLUMNS;
        } else {
            $cls = ShopShopsArchiveTableMap::OM_CLASS;
            /** @var ShopShopsArchive $obj */
            $obj = new $cls();
            $col = $obj->hydrate($row, $offset, false, $indexType);
            ShopShopsArchiveTableMap::addInstanceToPool($obj, $key);
        }

        return array($obj, $col);
    }

    /**
     * The returned array will contain objects of the default type or
     * objects that inherit from the default.
     *
     * @param DataFetcherInterface $dataFetcher
     * @return array
     * @throws PropelException Any exceptions caught during processing will be
     *                         rethrown wrapped into a PropelException.
     */
    public static function populateObjects(DataFetcherInterface $dataFetcher)
    {
        $results = array();

        // set the class once to avoid overhead in the loop
        $cls = static::getOMClass(false);
        // populate the object(s)
        while ($row = $dataFetcher->fetch()) {
            $key = ShopShopsArchiveTableMap::getPrimaryKeyHashFromRow($row, 0, $dataFetcher->getIndexType());
            if (null !== ($obj = ShopShopsArchiveTableMap::getInstanceFromPool($key))) {
                // We no longer rehydrate the object, since this can cause data loss.
                // See http://www.propelorm.org/ticket/509
                // $obj->hydrate($row, 0, true); // rehydrate
                $results[] = $obj;
            } else {
                /** @var ShopShopsArchive $obj */
                $obj = new $cls();
                $obj->hydrate($row);
                $results[] = $obj;
                ShopShopsArchiveTableMap::addInstanceToPool($obj, $key);
            } // if key exists
        }

        return $results;
    }
    /**
     * Add all the columns needed to create a new object.
     *
     * Note: any columns that were marked with lazyLoad="true" in the
     * XML schema will not be added to the select list and only loaded
     * on demand.
     *
     * @param Criteria $criteria object containing the columns to add.
     * @param string   $alias    optional table alias
     * @throws PropelException Any exceptions caught during processing will be
     *                         rethrown wrapped into a PropelException.
     */
    public static function addSelectColumns(Criteria $criteria, $alias = null)
    {
        if (null === $alias) {
            $criteria->addSelectColumn(ShopShopsArchiveTableMap::COL_ID);
            $criteria->addSelectColumn(ShopShopsArchiveTableMap::COL_TITLE);
            $criteria->addSelectColumn(ShopShopsArchiveTableMap::COL_DESC);
            $criteria->addSelectColumn(ShopShopsArchiveTableMap::COL_IMAGE);
            $criteria->addSelectColumn(ShopShopsArchiveTableMap::COL_LOGO);
            $criteria->addSelectColumn(ShopShopsArchiveTableMap::COL_DIRECTOR_CONTACT);
            $criteria->addSelectColumn(ShopShopsArchiveTableMap::COL_PHONES);
            $criteria->addSelectColumn(ShopShopsArchiveTableMap::COL_EMAILS);
            $criteria->addSelectColumn(ShopShopsArchiveTableMap::COL_TYPE);
            $criteria->addSelectColumn(ShopShopsArchiveTableMap::COL_PARENT_ID);
            $criteria->addSelectColumn(ShopShopsArchiveTableMap::COL_DOMAIN_ID);
            $criteria->addSelectColumn(ShopShopsArchiveTableMap::COL_ACTIVE);
            $criteria->addSelectColumn(ShopShopsArchiveTableMap::COL_CONTRACTOR_ID);
            $criteria->addSelectColumn(ShopShopsArchiveTableMap::COL_ARCHIVED_AT);
        } else {
            $criteria->addSelectColumn($alias . '.id');
            $criteria->addSelectColumn($alias . '.title');
            $criteria->addSelectColumn($alias . '.desc');
            $criteria->addSelectColumn($alias . '.image');
            $criteria->addSelectColumn($alias . '.logo');
            $criteria->addSelectColumn($alias . '.director_contact');
            $criteria->addSelectColumn($alias . '.phones');
            $criteria->addSelectColumn($alias . '.emails');
            $criteria->addSelectColumn($alias . '.type');
            $criteria->addSelectColumn($alias . '.parent_id');
            $criteria->addSelectColumn($alias . '.domain_id');
            $criteria->addSelectColumn($alias . '.active');
            $criteria->addSelectColumn($alias . '.contractor_id');
            $criteria->addSelectColumn($alias . '.archived_at');
        }
    }

    /**
     * Returns the TableMap related to this object.
     * This method is not needed for general use but a specific application could have a need.
     * @return TableMap
     * @throws PropelException Any exceptions caught during processing will be
     *                         rethrown wrapped into a PropelException.
     */
    public static function getTableMap()
    {
        return Propel::getServiceContainer()->getDatabaseMap(ShopShopsArchiveTableMap::DATABASE_NAME)->getTable(ShopShopsArchiveTableMap::TABLE_NAME);
    }

    /**
     * Add a TableMap instance to the database for this tableMap class.
     */
    public static function buildTableMap()
    {
        $dbMap = Propel::getServiceContainer()->getDatabaseMap(ShopShopsArchiveTableMap::DATABASE_NAME);
        if (!$dbMap->hasTable(ShopShopsArchiveTableMap::TABLE_NAME)) {
            $dbMap->addTableObject(new ShopShopsArchiveTableMap());
        }
    }

    /**
     * Performs a DELETE on the database, given a ShopShopsArchive or Criteria object OR a primary key value.
     *
     * @param mixed               $values Criteria or ShopShopsArchive object or primary key or array of primary keys
     *              which is used to create the DELETE statement
     * @param  ConnectionInterface $con the connection to use
     * @return int             The number of affected rows (if supported by underlying database driver).  This includes CASCADE-related rows
     *                         if supported by native driver or if emulated using Propel.
     * @throws PropelException Any exceptions caught during processing will be
     *                         rethrown wrapped into a PropelException.
     */
     public static function doDelete($values, ConnectionInterface $con = null)
     {
        if (null === $con) {
            $con = Propel::getServiceContainer()->getWriteConnection(ShopShopsArchiveTableMap::DATABASE_NAME);
        }

        if ($values instanceof Criteria) {
            // rename for clarity
            $criteria = $values;
        } elseif ($values instanceof \Shop\Models\Shop\ShopShopsArchive) { // it's a model object
            // create criteria based on pk values
            $criteria = $values->buildPkeyCriteria();
        } else { // it's a primary key, or an array of pks
            $criteria = new Criteria(ShopShopsArchiveTableMap::DATABASE_NAME);
            $criteria->add(ShopShopsArchiveTableMap::COL_ID, (array) $values, Criteria::IN);
        }

        $query = ShopShopsArchiveQuery::create()->mergeWith($criteria);

        if ($values instanceof Criteria) {
            ShopShopsArchiveTableMap::clearInstancePool();
        } elseif (!is_object($values)) { // it's a primary key, or an array of pks
            foreach ((array) $values as $singleval) {
                ShopShopsArchiveTableMap::removeInstanceFromPool($singleval);
            }
        }

        return $query->delete($con);
    }

    /**
     * Deletes all rows from the shop_shops_archive table.
     *
     * @param ConnectionInterface $con the connection to use
     * @return int The number of affected rows (if supported by underlying database driver).
     */
    public static function doDeleteAll(ConnectionInterface $con = null)
    {
        return ShopShopsArchiveQuery::create()->doDeleteAll($con);
    }

    /**
     * Performs an INSERT on the database, given a ShopShopsArchive or Criteria object.
     *
     * @param mixed               $criteria Criteria or ShopShopsArchive object containing data that is used to create the INSERT statement.
     * @param ConnectionInterface $con the ConnectionInterface connection to use
     * @return mixed           The new primary key.
     * @throws PropelException Any exceptions caught during processing will be
     *                         rethrown wrapped into a PropelException.
     */
    public static function doInsert($criteria, ConnectionInterface $con = null)
    {
        if (null === $con) {
            $con = Propel::getServiceContainer()->getWriteConnection(ShopShopsArchiveTableMap::DATABASE_NAME);
        }

        if ($criteria instanceof Criteria) {
            $criteria = clone $criteria; // rename for clarity
        } else {
            $criteria = $criteria->buildCriteria(); // build Criteria from ShopShopsArchive object
        }


        // Set the correct dbName
        $query = ShopShopsArchiveQuery::create()->mergeWith($criteria);

        // use transaction because $criteria could contain info
        // for more than one table (I guess, conceivably)
        return $con->transaction(function () use ($con, $query) {
            return $query->doInsert($con);
        });
    }

} // ShopShopsArchiveTableMap
// This is the static code needed to register the TableMap for this table with the main Propel class.
//
ShopShopsArchiveTableMap::buildTableMap();
